# MagiC-3 #

MagiC is a software package designed to perform systematic structure-based
coarse-graining of molecular models, in which the effective pairwise
potentials between coarse-grained sites of low-resolution molecular models
are constructed to reproduce structural distribution functions obtained from
modeling of systems in a high resolution (atomistic) description. The
software takes as input atomistic trajectories generated by an external
molecular dynamics package, and produce as an output interaction potentials
for coarse-grained models using Inverse Monte Carlo or Iterative Boltzmann
Inversion methods. The resulting potentials can be directly used in an
external coarse-grained simulation package.

This is the *third* version of MagiC. 

Please follow us on the BitBucket to get updated on the new features
and releases of the code. We are grateful for any discussions,
suggestions as well as [bug-reports](https://bitbucket.org/magic-su/magic-3/issues?status=new&status=open).

## Package structure

### Files:

README.md                - this file
INSTALL                  - brief installation instructions
install.sh		 - script for default installation
setvars.sh, setvars.csh  - script for setting environmental variables

### Directories:

bin                      - directory for compiled binaries
CGTraj                   - directory with the source code for CGTraj module
lib                      - directory with xdr library to read .xtc and .trr trajectories
magic                    - directory with the source code for the main MagiC module
MagicTools               - directory for the source code of MagicTools module
UserGuide		 - directory for the user guide

## Get the code 

The most recent stable release shall be pulled from the repository:
`hg clone https://bitbucket.org/magic-su/magic-3`


## How to Install

see file INSTALL

or

[Installation manual at bitbucket](https://bitbucket.org/magic-su/magic-3/wiki/How_To_Install/)


## Manual

see directory UserGuide

## What's new

[What's new](https://bitbucket.org/magic-su/magic-3/wiki/WhatsNew/)


## Tutorials

Here we have a growing set of tutorials, which illustate use cases of MagiC
on a real-life examples:
<https://bitbucket.org/magic-su/magic-3-tutorials>

## Reference

The theory and principles behind MagiC (version 1) are published in:  
[ A. Mirzoev, A.P.Lyubartsev "MagiC: Software Package for Multiscale Modeling"
J. Chem. Theory and Computations, 9(3), 1512-1520 (2013) ]
(http://pubs.acs.org/doi/abs/10.1021/ct301019v)   

## Keep in touch 
Follow us on Bitbucket.org to be notified about all
minor code changes. If you prefer to be contacted less frequently,
join our [mailing list]
(https://groups.google.com/forum/#!forum/magic-cg-software),
where we will be posting announces about new features and tutorials.


## Who do I talk to? 

* Prof. Alexander Lyubartsev (alexander.lyubartsev@mmk.su.se) -
Principal investigator and method developer
* Dr. Alexander Mirzoev (alexander.mirzoev@outlook.com) -
Main software developer

## Test-set 
The set of tests used for checking consistency of the code can be fond here:
<https://bitbucket.org/magic-su/magic-3-tests>

## Acknowledgements ##

We would like to thank National Supercomputing Centre Singapore
<https://www.nscc.sg/> 
for providing access to the state-of-the-art high performance software
development tools and compilers, as well as for organization of knowledge
sharing events and workshops.
